type 'a stream = Nil | Cons of 'a * 'a stream Lazy.t
  
let force = Lazy.force_val

let rec (++) = fun s1 s2 ->
  match s1 with
    | Nil -> s2
    | Cons (head, tail) -> Cons (head, lazy (force tail ++ s2))
