type 'a prioritySQ

val unit : 'a -> int -> 'a prioritySQ
val zero : unit -> 'a prioritySQ

val is_empty : 'a prioritySQ -> bool
val lookup : 'a -> 'a prioritySQ -> int
val max_element : 'a prioritySQ -> 'a
val min_tail : 'a prioritySQ -> 'a prioritySQ
val min_view : 'a prioritySQ -> ('a * int) * 'a prioritySQ

val insert : 'a -> int -> 'a prioritySQ -> 'a prioritySQ
val delete : 'a -> 'a prioritySQ -> 'a prioritySQ

val to_list : 'a prioritySQ -> ('a * int) list
val from_list : ('a * int) list -> 'a prioritySQ


