type ('a, 'b) lexicalMap 

val moduleName : string

val injection : 'a list -> 'b -> ('a, 'b) lexicalMap
val zero : unit -> ('a, 'b) lexicalMap

val to_list : ('a, 'b) lexicalMap -> ('a list * 'b) list

val insert_raise : 'a list -> 'b -> ('a, 'b) lexicalMap -> ('a, 'b) lexicalMap
val insert       : 'a list -> 'b -> ('a, 'b) lexicalMap -> ('a, 'b) lexicalMap

val delete_raise : 'a list -> ('a, 'b) lexicalMap -> ('a, 'b) lexicalMap
val delete       : 'a list -> ('a, 'b) lexicalMap -> ('a, 'b) lexicalMap

val is_empty : ('a, 'b) lexicalMap -> bool
val size     : ('a, 'b) lexicalMap -> int

val images   : ('a, 'b) lexicalMap -> 'b list

val member   : 'a list -> ('a, 'b) lexicalMap -> bool

val lookup   : 'a list -> ('a, 'b) lexicalMap -> 'b

val iter : ('a list -> 'b -> unit) -> ('a, 'b) lexicalMap -> unit
