type 'a trie

val moduleName : string

val injection : 'a list -> 'a trie
val zero : unit -> 'a trie

val to_list : 'a trie -> 'a list list

val insert       : 'a list -> 'a trie -> 'a trie
val insert_raise : 'a list -> 'a trie -> 'a trie

val delete       : 'a list -> 'a trie -> 'a trie
val delete_raise : 'a list -> 'a trie -> 'a trie

val is_empty : 'a trie -> bool

val member : 'a list -> 'a trie -> bool

val iter : ('a list -> unit) -> 'a trie -> unit
